(define %guile-build-info '((exec_prefix . "/usr") (prefix . "/usr") (bindir . "/usr/bin") (sbindir . "/usr/sbin") (libexecdir . "/usr/lib") (datarootdir . "/usr/share") (datadir . "/usr/share") (pkgdatadir . "/usr/share/guile") (sysconfdir . "/etc") (sharedstatedir . "/usr/com") (localstatedir . "/var/lib") (includedir . "/usr/include") (pkgincludedir . "/usr/include/guile") (infodir . "/usr/share/info") (htmldir . "") (libdir . "/usr/lib64") (pkglibdir . "/usr/lib64/guile") (localedir . "/usr/share/locale") (mandir . "/usr/share/man") (LIBS . "-lm ") (guileversion . "1.4.1.114") (scheme_site_dir . "/usr/share/guile/site") (libguileinterface . "11:0:2")))
(define(unspecified)(if #f #f))
(define(provide sym)(if(memq sym *features*)(unspecified)(set! *features*(cons sym *features*))))
(define(provided? feature)(and(memq feature *features*)#t))
(define feature? provided?)
(set! apply(lambda (fun . args)(@apply fun(apply:nconc2last args))))
(set-procedure-property! apply  'name  'apply)
(define(call-with-current-continuation proc)(@call-with-current-continuation proc))
(define OPEN_READ "r")
(define OPEN_WRITE "w")
(define OPEN_BOTH "r+")
(define *null-device* "/dev/null")
(define(open-input-file str)(open-file str OPEN_READ))
(define(open-output-file str)(open-file str OPEN_WRITE))
(define(open-io-file str)(open-file str OPEN_BOTH))
(define close-io-port close-port)
(define(call-with-input-file str proc)(let*((file(open-input-file str))(ans(proc file)))(close-input-port file)ans))
(define(call-with-output-file str proc)(let*((file(open-output-file str))(ans(proc file)))(close-output-port file)ans))
(define(with-input-from-port port thunk)(let*((swaports(lambda()(set! port(set-current-input-port port)))))(dynamic-wind swaports thunk swaports)))
(define(with-output-to-port port thunk)(let*((swaports(lambda()(set! port(set-current-output-port port)))))(dynamic-wind swaports thunk swaports)))
(define(with-error-to-port port thunk)(let*((swaports(lambda()(set! port(set-current-error-port port)))))(dynamic-wind swaports thunk swaports)))
(define(with-input-from-file file thunk)(let*((nport(open-input-file file))(ans(with-input-from-port nport thunk)))(close-port nport)ans))
(define(with-output-to-file file thunk)(let*((nport(open-output-file file))(ans(with-output-to-port nport thunk)))(close-port nport)ans))
(define(with-error-to-file file thunk)(let*((nport(open-output-file file))(ans(with-error-to-port nport thunk)))(close-port nport)ans))
(define(with-input-from-string string thunk)(call-with-input-string string(lambda(p)(with-input-from-port p thunk))))
(define(with-output-to-string thunk)(call-with-output-string(lambda(p)(with-output-to-port p thunk))))
(define(with-error-to-string thunk)(call-with-output-string(lambda(p)(with-error-to-port p thunk))))
(define the-eof-object(call-with-input-string ""(lambda(p)(read-char p))))
(if(not(defined?  '%load-verbosely))(define %load-verbosely #f))
(define(assert-load-verbosity v)(set! %load-verbosely v))
(define(%load-announce file)(and %load-verbosely(with-output-to-port(current-error-port)(lambda()(display ";;; loading ")(display file)(newline)(force-output)))))
(set! %load-hook %load-announce)
(define(load name)(start-stack  'load-stack(primitive-load name)))
(define format simple-format)
(define (object->string obj . printer)(if(null? printer)(simple-format #f "~S" obj)(with-output-to-string(lambda()((car printer)obj)))))
(define (peek . stuff)(newline)(display ";;; ")(write stuff)(newline)(car(last-pair stuff)))
(define pk peek)
(define (warn . stuff)(with-output-to-port(current-error-port)(lambda()(newline)(display ";;; WARNING ")(display stuff)(newline)(car(last-pair stuff)))))
(define(unspecified? obj)(eq?(unspecified)obj))
(define(id x)x)
(define(identity x)x)
(define(1+ n)(+ n 1))
(define(-1+ n)(+ n -1))
(define(1- n)(-1+ n))
(define (return-it . args)(apply noop args))
(define(and=> value procedure)(and value(procedure value)))
(define(hash-table? obj)(and(vector? obj)(let((rv #t)(len(vector-length obj))(ok?(lambda(x)(or(null? x)(list? x)))))(do((i 0(1+ i)))((or(not rv)(= i len)))(or(ok?(vector-ref obj i))(set! rv #f)))rv)))
(define (make-hash-table . args)(cond((null? args)(set! args '(#:size 61)))((number?(car args))(set! args(quasiquote(#:size(unquote-splicing args))))))(let((test  'eqv?)(size 61)(rehash-size 1.5)(make #f)(make-nonweak-hash-table(lambda(n)(make-vector n '()))))(let loop((ls args))(or(null? ls)(let*((kwa(car ls))(val(if(null?(cdr ls))(error "missing value for keyword:" kwa)(cadr ls))))(case kwa((#:size)(set! size val)(loop(cddr ls)))((#:weakness)(set! make(case val((#f)make-nonweak-hash-table)((#:key-and-value #t)make-doubly-weak-hash-table)((#:key)make-weak-key-hash-table)((#:value)make-weak-value-hash-table)(else(error "bad #:weakness:" val))))(loop(cddr ls)))))))((or make make-nonweak-hash-table)size)))
(define(hash-for-each proc table)(hash-fold(lambda(key value prior-ignored)(proc key value))(unspecified)table))
(define(apply-to-args args proc)(apply proc args))
(define(ipow-by-squaring x k acc proc)(cond((zero? k)acc)((= 1 k)(proc acc x))(else(ipow-by-squaring(proc x x)(quotient k 2)(if(even? k)acc(proc acc x))proc))))
(define string-character-length string-length)
(define flags logior)
(define(symbol-property sym prop)(let((pair(assoc prop(symbol-pref sym))))(and pair(cdr pair))))
(define(set-symbol-property! sym prop val)(let((pair(assoc prop(symbol-pref sym))))(if pair(set-cdr! pair val)(symbol-pset! sym(acons prop val(symbol-pref sym))))))
(define(symbol-property-remove! sym prop)(cond((assoc prop(symbol-pref sym))=>(lambda(pair)(symbol-pset! sym(delq! pair(symbol-pref sym)))))))
(define (make-object-property . opts)(let((dv(and(not(null? opts))(car opts)))(ht(make-hash-table #:weakness #:key)))(make-procedure-with-setter(lambda(obj)(hashq-ref ht obj dv))(lambda(obj val)(if(eq? val dv)(begin(hashq-remove! ht obj)dv)(hashq-set! ht obj val))))))
(define(uniform-vector? obj)(array? obj))
(define (make-uniform-vector length prototype . fill)(dimensions->uniform-array length prototype(if(null? fill)prototype(car fill))))
(define(uniform-vector-set! uve i obj)(uniform-array-set1! uve obj i))
(define(uniform-vector-fill! uve fill)(array-fill! uve fill))
(define uniform-vector-read! uniform-array-read!)
(define uniform-vector-write uniform-array-write)
(define (make-array fill . args)(dimensions->uniform-array args '()fill))
(define (make-uniform-array prot . args)(dimensions->uniform-array args prot))
(define(list->array ndim lst)(list->uniform-array ndim '()lst))
(define(list->uniform-vector prot lst)(list->uniform-array 1 prot lst))
(define(array-shape a)(map(lambda(ind)(if(number? ind)(list 0(+ -1 ind))ind))(array-dimensions a)))
(define(read:uniform-vector proto port)(if(eq? #\((peek-char port))(list->uniform-array 1 proto(read port))(error "read:uniform-vector list not found")))
(let((make-array-proc(lambda(template)(lambda(c port)(read:uniform-vector template port)))))(for-each(lambda(char template)(read-hash-extend char(make-array-proc template))) '(#\b #\a #\u #\e #\s #\i #\c #\y #\h #\l) '(#t #\a 1 -1 1.0 0.333333333333333 0.0+1.0i #\nul s l)))
(define(read:array digit port)(let*((chr0(char->integer #\0))(rank(let readnum((val(-(char->integer digit)chr0)))(if(char-numeric?(peek-char port))(readnum(+(* 10 val)(-(char->integer(read-char port))chr0)))val)))(prot(if(eq? #\((peek-char port)) '()(let((c(read-char port)))(case c((#\b)#t)((#\a)#\a)((#\u)1)((#\e)-1)((#\s)1.0)((#\i)0.333333333333333)((#\c)0.0+1.0i)(else(error "read:array unknown option " c)))))))(if(eq?(peek-char port)#\()(list->uniform-array rank prot(read port))(error "read:array list not found"))))
(let*((beg(char->integer #\0))(end(+ beg 10)))(do((i beg(1+ i)))((= end i))(read-hash-extend(integer->char i)read:array)))
(define (symbol-append . symbols)(string->symbol(apply string-append symbols)))
(define(list->symbol chars)(string->symbol(list->string chars)))
(define (symbol . chars)(string->symbol(apply string chars)))
(define (obarray-symbol-append ob . symbols)(string->obarray-symbol(apply string-append ob symbols)))
(define (obarray-gensym obarray . opt)(if(null? opt)(gensym "%%gensym" obarray)(gensym(car opt)obarray)))
(define(symbol->keyword symbol)(make-keyword-from-dash-symbol(symbol-append  '- symbol)))
(define(keyword->symbol kw)(let((sym(keyword-dash-symbol kw)))(string->symbol(substring sym 1(string-length sym)))))
(define(kw-arg-ref args kw)(let((rem(memq kw args)))(and rem(pair?(cdr rem))(cadr rem))))
(define(iota n)(let loop((n(1- n))(result '()))(if(< n 0)result(loop(1- n)(cons n result)))))
(define(list-index l k)(let loop((n 0)(l l))(and(not(null? l))(if(eq?(car l)k)n(loop(+ n 1)(cdr l))))))
(define (make-list n . init)(and(pair? init)(set! init(car init)))(let loop((answer '())(n n))(if(<= n 0)answer(loop(cons init answer)(- n 1)))))
(define(struct-layout s)(struct-ref(struct-vtable s)vtable-index-layout))
(define(inherit-print-state old-port new-port)(if(get-print-state old-port)(port-with-print-state new-port(get-print-state old-port))new-port))
(define record-type-vtable(make-vtable-vtable "prpr" 0(lambda(s p)(cond((eq? s record-type-vtable)(display "#<record-type-vtable>" p))(else(display "#<record-type " p)(display(struct-ref s vtable-offset-user)p)(display ">" p))))))
(define(record-type? obj)(and(struct? obj)(eq? record-type-vtable(struct-vtable obj))))
(define(record-type-name obj)(if(record-type? obj)(struct-ref obj vtable-offset-user)(error  'not-a-record-type obj)))
(define (make-record-type type-name fields . opt)(let*((n(length fields))(layout-spec(apply symbol-append(make-list n "pw")))(printer(or(and(pair? opt)(car opt))(lambda(s p)(display "#<" p)(display type-name p)(for-each(lambda(field i)(display " " p)(display field p)(display ": " p)(display(struct-ref s i)p))fields(iota n))(display ">" p))))(struct(make-struct record-type-vtable 0(make-struct-layout layout-spec)printer type-name(copy-tree fields))))(set-struct-vtable-name! struct(if(symbol? type-name)type-name(string->symbol type-name)))struct))
(define(record-type-fields obj)(if(record-type? obj)(struct-ref obj(+ 1 vtable-offset-user))(error  'not-a-record-type obj)))
(define (record-constructor rtd . opt)(let((field-names(if(pair? opt)(car opt)(record-type-fields rtd))))(eval(quasiquote(lambda(unquote field-names)(make-struct '(unquote rtd)0(unquote-splicing(map(lambda(f)(if(memq f field-names)f #f))(record-type-fields rtd)))))))))
(define(record-predicate rtd)(lambda(obj)(and(struct? obj)(eq? rtd(struct-vtable obj)))))
(define(record-type-descriptor obj)(if(struct? obj)(struct-vtable obj)(error  'not-a-record obj)))
(define(record-accessor rtd field-name)(let((pos(or(list-index(record-type-fields rtd)field-name)(error  'no-such-field field-name))))(lambda(obj)(and(eq? rtd(record-type-descriptor obj))(struct-ref obj pos)))))
(define(record-modifier rtd field-name)(let((pos(or(list-index(record-type-fields rtd)field-name)(error  'no-such-field field-name))))(lambda(obj val)(and(eq? rtd(record-type-descriptor obj))(struct-set! obj pos val)))))
(define(record? obj)(and(struct? obj)(record-type?(struct-vtable obj))))
(provide  'record)
(define(->bool obj)(and obj #t))
(define *values-rtd*(make-record-type "values" '(values)))
(define values(let((make-values(record-constructor *values-rtd*)))(lambda x(if(and(not(null? x))(null?(cdr x)))(car x)(make-values x)))))
(define call-with-values(let((access-values(record-accessor *values-rtd*  'values))(values-predicate?(record-predicate *values-rtd*)))(lambda(producer consumer)(let((result(producer)))(if(values-predicate? result)(apply consumer(access-values result))(consumer result))))))
(provide  'values)
(define(and-map proc lst)(let loop((result #t)(l lst))(and result(or(and(null? l)result)(loop(proc(car l))(cdr l))))))
(define(or-map proc lst)(let loop((result #f)(l lst))(or result(and(not(null? l))(loop(proc(car l))(cdr l))))))
(define(stat:dev f)(vector-ref f 0))
(define(stat:ino f)(vector-ref f 1))
(define(stat:mode f)(vector-ref f 2))
(define(stat:nlink f)(vector-ref f 3))
(define(stat:uid f)(vector-ref f 4))
(define(stat:gid f)(vector-ref f 5))
(define(stat:rdev f)(vector-ref f 6))
(define(stat:size f)(vector-ref f 7))
(define(stat:atime f)(vector-ref f 8))
(define(stat:mtime f)(vector-ref f 9))
(define(stat:ctime f)(vector-ref f 10))
(define(stat:blksize f)(vector-ref f 11))
(define(stat:blocks f)(vector-ref f 12))
(define(stat:type f)(vector-ref f 13))
(define(stat:perms f)(vector-ref f 14))
(define(passwd:name obj)(vector-ref obj 0))
(define(passwd:passwd obj)(vector-ref obj 1))
(define(passwd:uid obj)(vector-ref obj 2))
(define(passwd:gid obj)(vector-ref obj 3))
(define(passwd:gecos obj)(vector-ref obj 4))
(define(passwd:dir obj)(vector-ref obj 5))
(define(passwd:shell obj)(vector-ref obj 6))
(define(group:name obj)(vector-ref obj 0))
(define(group:passwd obj)(vector-ref obj 1))
(define(group:gid obj)(vector-ref obj 2))
(define(group:mem obj)(vector-ref obj 3))
(define(utsname:sysname obj)(vector-ref obj 0))
(define(utsname:nodename obj)(vector-ref obj 1))
(define(utsname:release obj)(vector-ref obj 2))
(define(utsname:version obj)(vector-ref obj 3))
(define(utsname:machine obj)(vector-ref obj 4))
(define(getpwent)(getpw))
(define(setpwent)(setpw #t))
(define(endpwent)(setpw))
(define(getpwnam name)(getpw name))
(define(getpwuid uid)(getpw uid))
(define(getgrent)(getgr))
(define(setgrent)(setgr #f))
(define(endgrent)(setgr))
(define(getgrnam name)(getgr name))
(define(getgrgid id)(getgr id))
(define(gethostbyaddr addr)(gethost addr))
(define(gethostbyname name)(gethost name))
(define(getnetbyaddr addr)(getnet addr))
(define(getnetbyname name)(getnet name))
(define(getprotobyname name)(getproto name))
(define(getprotobynumber addr)(getproto addr))
(define(getservbyname name proto)(getserv name proto))
(define(getservbyport port proto)(getserv port proto))
(define (sethostent . stayopen)(if(pair? stayopen)(sethost(car stayopen))(sethost #f)))
(define (setnetent . stayopen)(if(pair? stayopen)(setnet(car stayopen))(setnet #f)))
(define (setprotoent . stayopen)(if(pair? stayopen)(setproto(car stayopen))(setproto #f)))
(define (setservent . stayopen)(if(pair? stayopen)(setserv(car stayopen))(setserv #f)))
(define(gethostent)(gethost))
(define(getnetent)(getnet))
(define(getprotoent)(getproto))
(define(getservent)(getserv))
(define(endhostent)(sethost))
(define(endnetent)(setnet))
(define(endprotoent)(setproto))
(define(endservent)(setserv))
(define(hostent:name obj)(vector-ref obj 0))
(define(hostent:aliases obj)(vector-ref obj 1))
(define(hostent:addrtype obj)(vector-ref obj 2))
(define(hostent:length obj)(vector-ref obj 3))
(define(hostent:addr-list obj)(vector-ref obj 4))
(define(netent:name obj)(vector-ref obj 0))
(define(netent:aliases obj)(vector-ref obj 1))
(define(netent:addrtype obj)(vector-ref obj 2))
(define(netent:net obj)(vector-ref obj 3))
(define(protoent:name obj)(vector-ref obj 0))
(define(protoent:aliases obj)(vector-ref obj 1))
(define(protoent:proto obj)(vector-ref obj 2))
(define(servent:name obj)(vector-ref obj 0))
(define(servent:aliases obj)(vector-ref obj 1))
(define(servent:port obj)(vector-ref obj 2))
(define(servent:proto obj)(vector-ref obj 3))
(define(sockaddr:fam obj)(vector-ref obj 0))
(define(sockaddr:path obj)(vector-ref obj 1))
(define(sockaddr:addr obj)(vector-ref obj 1))
(define(sockaddr:port obj)(vector-ref obj 2))
(define file-exists?(if(provided?  'posix)(lambda(str)(catch  'system-error(lambda()(and(stat str)#t))(lambda args #f)))(lambda(str)(let((port(catch  'system-error(lambda()(open-input-file str))(lambda args #f))))(if port(begin(close-port port)#t)#f)))))
(define file-is-directory?(if(provided?  'posix)(lambda(str)(eq?(stat:type(stat str)) 'directory))(lambda(str)(let((port(catch  'system-error(lambda()(open-input-file(string-append str "/.")))(lambda args #f))))(if port(begin(close-port port)#t)#f)))))
(define(has-suffix? str suffix)(let((sufl(string-length suffix))(sl(string-length str)))(and(> sl sufl)(string=?(substring str(- sl sufl)sl)suffix))))
(define scheme-file-suffix(lambda()".scm"))
(define(in-vicinity vicinity file)(let((tail(let((len(string-length vicinity)))(if(zero? len)#f(string-ref vicinity(- len 1))))))(string-append vicinity(if(or(not tail)(eq? tail #\/))"" "/")file)))
(define (error . args)(save-stack)(if(null? args)(scm-error  'misc-error #f "?" #f #f)(let loop((msg "~A")(rest(cdr args)))(if(not(null? rest))(loop(string-append msg " ~S")(cdr rest))(scm-error  'misc-error #f msg args #f)))))
(define (bad-throw key . args)(let((default(symbol-property key  'throw-handler-default)))(or(and default(apply default key args))(apply error "unhandled-exception:" key args))))
(define(tm:sec obj)(vector-ref obj 0))
(define(tm:min obj)(vector-ref obj 1))
(define(tm:hour obj)(vector-ref obj 2))
(define(tm:mday obj)(vector-ref obj 3))
(define(tm:mon obj)(vector-ref obj 4))
(define(tm:year obj)(vector-ref obj 5))
(define(tm:wday obj)(vector-ref obj 6))
(define(tm:yday obj)(vector-ref obj 7))
(define(tm:isdst obj)(vector-ref obj 8))
(define(tm:gmtoff obj)(vector-ref obj 9))
(define(tm:zone obj)(vector-ref obj 10))
(define(set-tm:sec obj val)(vector-set! obj 0 val))
(define(set-tm:min obj val)(vector-set! obj 1 val))
(define(set-tm:hour obj val)(vector-set! obj 2 val))
(define(set-tm:mday obj val)(vector-set! obj 3 val))
(define(set-tm:mon obj val)(vector-set! obj 4 val))
(define(set-tm:year obj val)(vector-set! obj 5 val))
(define(set-tm:wday obj val)(vector-set! obj 6 val))
(define(set-tm:yday obj val)(vector-set! obj 7 val))
(define(set-tm:isdst obj val)(vector-set! obj 8 val))
(define(set-tm:gmtoff obj val)(vector-set! obj 9 val))
(define(set-tm:zone obj val)(vector-set! obj 10 val))
(define(tms:clock obj)(vector-ref obj 0))
(define(tms:utime obj)(vector-ref obj 1))
(define(tms:stime obj)(vector-ref obj 2))
(define(tms:cutime obj)(vector-ref obj 3))
(define(tms:cstime obj)(vector-ref obj 4))
(define(port? obj)(or(input-port? obj)(output-port? obj)))
(define (file-position . args)(apply ftell args))
(define (file-set-position . args)(apply fseek args))
(define(move->fdes fd/port fd)(cond((integer? fd/port)(dup->fdes fd/port fd)(close fd/port)fd)(else(primitive-move->fdes fd/port fd)(set-port-revealed! fd/port 1)fd/port)))
(define(release-port-handle port)(let((revealed(port-revealed port)))(and(> revealed 0)(set-port-revealed! port(- revealed 1)))))
(define (dup->port port/fd mode . maybe-fd)(let((port(fdopen(apply dup->fdes port/fd maybe-fd)mode)))(and(pair? maybe-fd)(set-port-revealed! port 1))port))
(define (dup->inport port/fd . maybe-fd)(apply dup->port port/fd "r" maybe-fd))
(define (dup->outport port/fd . maybe-fd)(apply dup->port port/fd "w" maybe-fd))
(define (dup port/fd . maybe-fd)(if(integer? port/fd)(apply dup->fdes port/fd maybe-fd)(apply dup->port port/fd(port-mode port/fd)maybe-fd)))
(define(duplicate-port port modes)(dup->port port modes))
(define(fdes->inport fdes)(let loop((rest-ports(fdes->ports fdes)))(cond((null? rest-ports)(let((result(fdopen fdes "r")))(set-port-revealed! result 1)result))((input-port?(car rest-ports))(set-port-revealed!(car rest-ports)(+(port-revealed(car rest-ports))1))(car rest-ports))(else(loop(cdr rest-ports))))))
(define(fdes->outport fdes)(let loop((rest-ports(fdes->ports fdes)))(cond((null? rest-ports)(let((result(fdopen fdes "w")))(set-port-revealed! result 1)result))((output-port?(car rest-ports))(set-port-revealed!(car rest-ports)(+(port-revealed(car rest-ports))1))(car rest-ports))(else(loop(cdr rest-ports))))))
(define(port->fdes port)(set-port-revealed! port(+(port-revealed port)1))(fileno port))
(define(setenv name value)(if value(putenv(string-append name "=" value))(putenv name)))
(define(load-from-path name)(start-stack  'load-stack(primitive-load-path name)))
(define(exp z)(if(real? z)($exp z)(make-polar($exp(real-part z))(imag-part z))))
(define(log z)(if(and(real? z)(>= z 0))($log z)(make-rectangular($log(magnitude z))(angle z))))
(define(sqrt z)(if(real? z)(if(negative? z)(make-rectangular 0($sqrt(- z)))($sqrt z))(make-polar($sqrt(magnitude z))(/(angle z)2))))
(define(expt z1 z2)(cond((zero? z2)1)((integer? z2)(if(>= z2 0)(integer-expt z1 z2)(/ 1(integer-expt z1(- z2)))))((and(real? z2)(real? z1)(>= z1 0))($expt z1 z2))(else(exp(* z2(log z1))))))
(define(sinh z)(if(real? z)($sinh z)(let((x(real-part z))(y(imag-part z)))(make-rectangular(*($sinh x)($cos y))(*($cosh x)($sin y))))))
(define(cosh z)(if(real? z)($cosh z)(let((x(real-part z))(y(imag-part z)))(make-rectangular(*($cosh x)($cos y))(*($sinh x)($sin y))))))
(define(tanh z)(if(real? z)($tanh z)(let*((x(* 2(real-part z)))(y(* 2(imag-part z)))(w(+($cosh x)($cos y))))(make-rectangular(/($sinh x)w)(/($sin y)w)))))
(define(asinh z)(if(real? z)($asinh z)(log(+ z(sqrt(+(* z z)1))))))
(define(acosh z)(if(and(real? z)(>= z 1))($acosh z)(log(+ z(sqrt(-(* z z)1))))))
(define(atanh z)(if(and(real? z)(> z -1)(< z 1))($atanh z)(/(log(/(+ 1 z)(- 1 z)))2)))
(define(sin z)(if(real? z)($sin z)(let((x(real-part z))(y(imag-part z)))(make-rectangular(*($sin x)($cosh y))(*($cos x)($sinh y))))))
(define(cos z)(if(real? z)($cos z)(let((x(real-part z))(y(imag-part z)))(make-rectangular(*($cos x)($cosh y))(-(*($sin x)($sinh y)))))))
(define(tan z)(if(real? z)($tan z)(let*((x(* 2(real-part z)))(y(* 2(imag-part z)))(w(+($cos x)($cosh y))))(make-rectangular(/($sin x)w)(/($sinh y)w)))))
(define(asin z)(if(and(real? z)(>= z -1)(<= z 1))($asin z)(* 0.0-1.0i(asinh(* 0.0+1.0i z)))))
(define(acos z)(if(and(real? z)(>= z -1)(<= z 1))($acos z)(+(/(angle -1)2)(* 0.0+1.0i(asinh(* 0.0+1.0i z))))))
(define (atan z . y)(if(null? y)(if(real? z)($atan z)(/(log(/(- 0.0+1.0i z)(+ 0.0+1.0i z)))0.0+2.0i))($atan2 z(car y))))
(define(log10 arg)(/(log arg)(log 10)))
(read-hash-extend #\'(lambda(c port)(read port)))
(read-hash-extend #\.(lambda(c port)(eval(read port))))
(define (symbol-prefix-proc prefix . cut-spec)(if(null? cut-spec)(lambda(symbol)(symbol-append prefix symbol))(let((cut(car cut-spec)))(lambda(symbol)(string->symbol(simple-format #f "~A~A" prefix(substring(symbol->string symbol)cut)))))))
(let*((dl-self(dynamic-link #f))(bvec(vector(unspecified)(unspecified) '(%%app modules)dl-self(let((%%%(dynamic-func "scm_3percent" dl-self)))(lambda (c . args)(let((ls(cons c args)))(and(zero?(dynamic-args-call %%% dl-self(list(number->string(object-address ls)))))(cdr ls)))))))(BOOT(lambda (k . v)(case k((#:root)(vector-ref bvec 0))((#:root!)(vector-set! bvec 0(car v)))((#:scm)(vector-ref bvec 1))((#:scm!)(vector-set! bvec 1(car v)))((#:mpre)(vector-ref bvec 2))((#:self)(vector-ref bvec 3))((#:reg)(vector-ref bvec 4))))))(define(biv! symbol obj)(variable-set!(builtin-variable symbol)obj))(define LL(let*((BOOT BOOT)(-print #f)(td(make-record-type  'module '(obarray uses binder transformer name kind observers weak-observers observer-id eval-closure)(lambda(mod port)(-print mod port))))(-new(record-constructor td))(td-a(lambda(what)(record-accessor td what)))(td-m(lambda(what)(record-modifier td what)))(obarray(td-a  'obarray))(uses(td-a  'uses))(uses!(td-m  'uses))(binder(td-a  'binder))(transformer(td-a  'transformer))(transformer!(td-m  'transformer))(name(td-a  'name))(kind(td-a  'kind))(observers(td-a  'observers))(observers!(td-m  'observers))(weak-observers(td-a  'weak-observers))(observer-id(td-a  'observer-id))(observer-id!(td-m  'observer-id))(eval-closure(td-a  'eval-closure)))(define(module? obj)(and(record? obj)((record-predicate td)obj)))(define (new name kind . args)(define(parse-arg len index default)(if(> len index)(list-ref args index)default))(and(>(length args)3)(error "Too many args to 'new :" args))(let*((len(length args))(size(parse-arg len 0 1021))(binder(parse-arg len 1 #f)))(or(integer? size)(error "Illegal size to 'new :" size))(and binder(not(procedure? binder))(error "Lazy-binder expected to be a procedure or #f:" binder))(let*((module(-new(make-vector size '()) '()binder #f name kind '()(make-hash-table #:size 31 #:weakness #:value)0 #f))(closure(standard-eval-closure module)))((td-m  'eval-closure)module closure)(set-procedure-property! closure  'module module)module)))(define(new:directory parent child-name)(new(quasiquote((unquote-splicing(or(name parent) '()))(unquote(car child-name)))) 'directory 31))(define(new:interface parent)(new(name parent) 'interface 31))(define(new:autoload name binder)(-new #() '()binder #f name  'autoload '()(make-hash-table #:size 17 #:weakness #:value)0 #f))(define(obsproto:observe module proc)(observers! module(cons proc(observers module)))(cons module proc))(define(obsproto:observe-weak module proc)(let((id(observer-id module)))(hash-set!(weak-observers module)id proc)(observer-id! module(+ 1 id))(cons module id)))(define(obsproto:unobserve token)(let((module(car token))(id(cdr token)))(if(integer? id)(hash-remove!(weak-observers module)id)(observers! module(delq1! id(observers module)))))(unspecified))(define(obsproto:modified module)(for-each(lambda(proc)(proc module))(observers module))(hash-fold(lambda(id proc res)(proc module))#f(weak-observers module)))(define(set-system! m bool)(set-procedure-property!(eval-closure m) 'system-module bool))(define(module-use! module interface)(uses! module(cons interface(delq! interface(uses module))))(obsproto:modified module))(define(SMACO name magic)(and(eq? magic BOOT)(case name((#:eval-closure)eval-closure)(else #f))))(set! -print(lambda(mod port)(display "#<" port)(display(or(kind mod)"module")port)(cond((name mod)=>(lambda(n)(display " " port)(display n port))))(display " " port)(display(number->string(object-address mod)16)port)(display ">" port)))(lambda (command . args)(apply(case command((#:-print)-print)((#:module?)module?)((#:obarray)obarray)((#:uses)uses)((#:uses!)uses!)((#:binder)binder)((#:transformer)transformer)((#:transformer!)transformer!)((#:name)name)((#:kind)kind)((#:eval-closure)eval-closure)((#:new)new)((#:new:directory)new:directory)((#:new:interface)new:interface)((#:new:autoload)new:autoload)((#:obsproto:observe)obsproto:observe)((#:obsproto:observe-weak)obsproto:observe-weak)((#:obsproto:unobserve)obsproto:unobserve)((#:obsproto:modified)obsproto:modified)((#:set-system!)set-system!)((#:module-use!)module-use!)((#:SMACO)SMACO)(else(error "No such command:" command)))args))))(define OB(let((BOOT BOOT))(define(search fn llmod symbol)(define(loop pos)(and(pair? pos)(or(search fn(car pos)symbol)(loop(cdr pos)))))(or(fn llmod symbol)(loop(LL #:uses llmod))))(define(locvar llmod symbol)(let((b(ob-ref(LL #:obarray llmod)symbol)))(or(and(variable? b)b)(and=>(LL #:binder llmod)(lambda(bind)(bind llmod symbol #f))))))(define(var llmod symbol)(search locvar llmod symbol))(define(locally-bound? llmod symbol)(let((var(locvar llmod symbol)))(and var(variable-bound? var))))(define(bound? m v)(search locally-bound? m v))(define(ob-get-handle ob key)((if(symbol? key)hashq-get-handle hash-get-handle)ob key))(define(ob-ref ob key)((if(symbol? key)hashq-ref hash-ref)ob key))(define(ob-set! ob key val)((if(symbol? key)hashq-set! hash-set!)ob key val))(define(ob-remove! ob key)((if(symbol? key)hashq-remove! hash-remove!)ob key))(define(symbol-locally-interned? m v)(->bool(ob-get-handle(LL #:obarray m)v)))(define(symbol-interned? m v)(search symbol-locally-interned? m v))(define(make-local-var! m v)(or(let((b(ob-ref(LL #:obarray m)v)))(and(variable? b)(begin(LL #:obsproto:modified m)b)))(and=>(LL #:binder m)(lambda(bind)(bind m v #t)))(begin(let((answer(make-undefined-variable v)))(ob-set!(LL #:obarray m)v answer)(LL #:obsproto:modified m)answer))))(define(add! m v var)(or(variable? var)(error "Bad variable to module-add!" var))(ob-set!(LL #:obarray m)v var)(LL #:obsproto:modified m))(define(remove! m v)(ob-remove!(LL #:obarray m)v)(LL #:obsproto:modified m))(define(clear! m)(vector-fill!(LL #:obarray m) '())(LL #:obsproto:modified m))(define(m-for-each proc module)(let((obarray(LL #:obarray module)))(do((index 0(+ index 1))(end(vector-length obarray)))((= index end))(for-each(lambda(bucket)(proc(car bucket)(cdr bucket)))(vector-ref obarray index)))))(define(m-map proc module)(let*((obarray(LL #:obarray module))(end(vector-length obarray)))(let loop((i 0)(answer '()))(if(= i end)answer(loop(+ 1 i)(append!(map(lambda(bucket)(proc(car bucket)(cdr bucket)))(vector-ref obarray i))answer))))))(define (fob-ref module name . rest)(let((variable(var module name)))(if(and variable(variable-bound? variable))(variable-ref variable)(if(null? rest)(error "No variable named" name  'in module)(car rest)))))(define(fob-set! module name value)(let((variable(var module name)))(if variable(variable-set! variable value)(error "No variable named" name  'in module))))(define(fob-define! module name value)(let((variable(locvar module name)))(if variable(begin(variable-set! variable value)(LL #:obsproto:modified module))(add! module name(make-variable value name)))))(define(fob-defined? module name)(and=>(var module name)variable-bound?))(define(public-interface m)(fob-ref m  '%module-public-interface #f))(define(set-public-interface! m i)(fob-define! m  '%module-public-interface i))(define(SMACO name magic)(and(eq? magic BOOT)(case name((#:fob-ref)fob-ref)((#:fob-define!)fob-define!)(else #f))))(lambda (command . args)(apply(case command((#:search)search)((#:locvar)locvar)((#:var)var)((#:locally-bound?)locally-bound?)((#:bound?)bound?)((#:ob-ref)ob-ref)((#:ob-set!)ob-set!)((#:ob-remove!)ob-remove!)((#:symbol-locally-interned?)symbol-locally-interned?)((#:symbol-interned?)symbol-interned?)((#:make-local-var!)make-local-var!)((#:add!)add!)((#:remove!)remove!)((#:clear!)clear!)((#:m-for-each)m-for-each)((#:m-map)m-map)((#:fob-ref)fob-ref)((#:fob-set!)fob-set!)((#:fob-define!)fob-define!)((#:fob-defined?)fob-defined?)((#:public-interface)public-interface)((#:set-public-interface!)set-public-interface!)((#:SMACO)SMACO)(else(error "No such command:" command)))args))))(define PV(let((BOOT BOOT)(solipsist #f)(basic-load load))(define(focus)solipsist)(define(set-focus! m)(set! solipsist m)(if m(begin(set! *top-level-lookup-closure*(LL #:eval-closure solipsist))(biv!  'scm:eval-transformer(LL #:transformer solipsist)))(set! *top-level-lookup-closure* #f)))(define(save-excursion thunk)(let((inner-module(focus))(outer-module #f))(dynamic-wind(lambda()(set! outer-module(focus))(set-focus! inner-module)(set! inner-module #f))thunk(lambda()(set! inner-module(focus))(set-focus! outer-module)(set! outer-module #f)))))(define(module-aware-load filename)(save-excursion(lambda()(let((oldname(and(current-load-port)(port-filename(current-load-port)))))(basic-load(if(and oldname(>(string-length filename)0)(not(char=?(string-ref filename 0)#\/))(not(string=?(dirname oldname)".")))(in-vicinity(dirname oldname)filename)filename))))))(define(SMACO name magic)(and(eq? magic BOOT)(case name((#:focus)focus)((#:set-focus!)set-focus!)(else #f))))(lambda (command . args)(apply(case command((#:focus)focus)((#:set-focus!)set-focus!)((#:save-excursion)save-excursion)((#:basic-load)basic-load)((#:module-aware-load)module-aware-load)((#:SMACO)SMACO)(else(error "No such command:" command)))args))))(define NL(let((BOOT BOOT))(define(nested-ref root names)(let loop((cur root)(elts names))(cond((null? elts)cur)((not(LL #:module? cur))#f)(else(loop(OB #:fob-ref cur(car elts)#f)(cdr elts))))))(define(nested-set! root names val)(let loop((cur root)(elts names))(if(null?(cdr elts))(OB #:fob-set! cur(car elts)val)(loop(OB #:fob-ref cur(car elts))(cdr elts)))))(define(nested-define! root names val)(let loop((cur root)(elts names))(if(null?(cdr elts))(OB #:fob-define! cur(car elts)val)(loop(OB #:fob-ref cur(car elts))(cdr elts)))))(define(nested-remove! root names)(let loop((cur root)(elts names))(if(null?(cdr elts))(OB #:remove! cur(car elts))(loop(OB #:fob-ref cur(car elts))(cdr elts)))))(define(local-ref names)(nested-ref(PV #:focus)names))(define(local-set! names val)(nested-set!(PV #:focus)names val))(define(local-define names val)(nested-define!(PV #:focus)names val))(define(local-remove names)(nested-remove!(PV #:focus)names))(define(make-modules-in module name)(if(null? name)module(cond((OB #:fob-ref module(car name)#f)=>(lambda(m)(make-modules-in m(cdr name))))(else(let((m(LL #:new:directory module name)))(OB #:fob-define! module(car name)m)(make-modules-in m(cdr name)))))))(define(SMACO name magic)(and(eq? magic BOOT)(case name((#:local-ref)local-ref)((#:make-modules-in)make-modules-in)(else #f))))(lambda (command . args)(apply(case command((#:nested-ref)nested-ref)((#:nested-set!)nested-set!)((#:nested-define!)nested-define!)((#:nested-remove!)nested-remove!)((#:local-ref)local-ref)((#:local-set!)local-set!)((#:local-define)local-define)((#:local-remove)local-remove)((#:make-modules-in)make-modules-in)((#:SMACO)SMACO)(else(error "No such command:" command)))args))))(define MC(let*((--fastest-ht(make-object-property))(--faster-known(make-object-property))(catfrag ".module-catalog")(find #f)(merged-file(let((f(getenv "GUILE_MERGED_MODULE_CATALOG")))(and f(or(string=? "0" f)(file-exists? f))f))))(define(add! ht/size cat-file)(let((ht(if(number? ht/size)(make-hash-table #:size ht/size)ht/size))(p(open-input-file cat-file)))(for-each(lambda(entry)(let((key(car entry)))(hash-set! ht key(cdr entry))))(read p))(close-port p)ht))(define(fastest-find module)(hash-ref(or(--fastest-ht merged-file)(set!(--fastest-ht merged-file)(add! 113 merged-file)))module))(define (discover! . dirs)(for-each(lambda(dir)(set!(--faster-known dir)(let((cat(in-vicinity dir catfrag)))(if(file-exists? cat)(add! 31 cat)#:unavail))))(if(null? dirs)%load-path dirs)))(define(faster-find module)(let((base #f))(define(get-base)(or base(let((comps(map(lambda(x)(list "/"(symbol->string x)))(cdr module))))(set! base(apply string-append(symbol->string(car module))(apply append comps)))base)))(or-map(lambda(dir)(cond((--faster-known dir)=>(lambda(known)(if(eq? #:unavail known)(search-path(list dir)(get-base) '("" ".scm"))(hash-ref known module))))(else #f)))%load-path)))(define(set-catfrag! name)(and(string-index name #\/)(error "Directory component not permitted:" name))(set! catfrag name)(discover!))(set! find(if(and merged-file(not(string=? "0" merged-file)))fastest-find faster-find))(lambda (command . args)(cond((and(integer? command)(memq command '(0 -1)))(set! MC(lambda args #f)))(else(apply(case command((#:name-to-cat-entry)find)((#:set-catalog-name!)set-catfrag!)((#:recheck-catalogs!)discover!)(else(error "No such command:" command)))args))))))(define module-name->fob(let((BOOT BOOT))(lambda (name . maybe-autoload)(define(maybe-try!)(and(or(null? maybe-autoload)(car maybe-autoload))(or(CM #:try-linked name)(try-module-autoload name)(CM #:try-dynamic-link name))))(let((full-name(append(BOOT #:mpre)name)))(cond((NL #:local-ref full-name)=>(lambda(already)(or(OB #:fob-ref already  '%module-public-interface #f)(maybe-try!))already))(else(maybe-try!)(NL #:make-modules-in(PV #:focus)full-name)))))))(define resolve-interface(let((syms(map(lambda(kw)(cons kw(symbol-append  ':(keyword->symbol kw)))) '(#:select #:renamer #:prefix))))(lambda (name . args)(define(get-keyword-arg kw)(and=>(or(memq kw args)(memq(assq-ref syms kw)args))(lambda(kw-arg)(and(null?(cdr kw-arg))(error "keyword without value:" kw))(cadr kw-arg))))(let*((select(get-keyword-arg #:select))(renamer(or(and=>(get-keyword-arg #:renamer)(lambda(x)(and=>(eval x)(lambda(proc)(or(procedure? proc)(error "bad #:renamer"))proc))))(and=>(get-keyword-arg #:prefix)symbol-prefix-proc)identity))(module(module-name->fob name))(public-i(and module(OB #:public-interface module))))(and(or(not module)(not public-i))(error "no code for module" name))(if(and(not select)(eq? renamer  'identity))public-i(let((selection(or select(OB #:m-map(lambda(sym var)sym)public-i)))(custom-i(LL #:new:interface module)))(for-each(lambda(bspec)(let*((direct?(symbol? bspec))(orig(if direct? bspec(car bspec)))(seen(if direct? bspec(cdr bspec))))(OB #:add! custom-i(renamer seen)(or(OB #:locvar public-i orig)(OB #:locvar module orig)(error(simple-format #f "no binding `~A' in module ~A" orig name))))))selection)custom-i))))))(define AU(let((done '((guile)))(in-progress '()))(define(done-or-in-progress? n)(->bool(or(member n done)(member n in-progress))))(define(in-progress! n)(set! done(delete! n done))(set! in-progress(cons n in-progress)))(define(set-status! n done?)(cond(done?(set! in-progress(delete! n in-progress))(or(member n done)(set! done(cons n done))))(else(set! done(delete! n done))(set! in-progress(delete! n in-progress)))))(lambda (command . args)(apply(case command((#:done-or-in-progress?)done-or-in-progress?)((#:in-progress!)in-progress!)((#:set-status!)set-status!)(else(error "No such command:" command)))args))))(define try-module-autoload(lambda(module-name)(let*((reverse-name(reverse module-name))(dir-hint-module-name(reverse(cdr reverse-name))))(module-name->fob dir-hint-module-name #f)(and(not(AU #:done-or-in-progress? module-name))(let*((didit #f)(yes!(lambda(full)(PV #:save-excursion(lambda()(primitive-load full)))(set! didit #t))))(dynamic-wind(lambda()(AU #:in-progress! module-name))(lambda()(cond((MC #:name-to-cat-entry module-name)=>(lambda(full)(and(string? full)(yes! full))))((%search-load-path(in-vicinity(apply symbol-append(map(lambda(elt)(symbol-append elt "/"))dir-hint-module-name))(car reverse-name)))=> yes!)))(lambda()(AU #:set-status! module-name didit)))didit)))))(define CM(let((BOOT BOOT)(tbi '())(first-time? #t))(define (tbi! dynobj . upstream-n+i-alist)(define(merge+add! module-name vers init-func sk-up)(let*((pre(list-copy upstream-n+i-alist))(n/i(map(lambda(sk)(or(and=>(assoc sk pre)(lambda(ent)(set! pre(delq! ent pre))(cdr ent)))sk))sk-up)))(set! tbi(cons(list module-name vers init-func dynobj(append!(map cdr pre)n/i))tbi))))(for-each(lambda(crme)(apply-to-args crme merge+add!))((BOOT #:reg)"?"))((BOOT #:reg)"0"))(define(init module-name)(cond((assoc module-name tbi)=>(lambda(tbie)(apply-to-args(cdr tbie)(lambda(vers init-func dynobj upstreams)(let((mod(module-name->fob module-name #f))(uses(map(lambda(n-or-i)(if(pair? n-or-i)(resolve-interface n-or-i)n-or-i))upstreams)))(PV #:save-excursion(lambda()(PV #:set-focus! mod)(OB #:set-public-interface! mod mod)(for-each(lambda(use)(LL #:module-use! mod use))(cons(BOOT #:scm)uses))(cond((= 0 vers)(dynamic-call init-func dynobj))((= 1 vers)((BOOT #:reg)"i" init-func))(else(error "WEIRDNESS!")))(set! tbi(delq! tbie tbi)))))#t))))(else #f)))(define(find+link module-name)(let((sharlib-full #f)(upstreams #f)(C-link-init-func #f)(spec-name #f)(look(MC #:name-to-cat-entry module-name)))(cond((and(pair? look)(eq?  'spec(car look))(cdr look))=>(lambda(looked)(set! sharlib-full(cdr(last-pair looked)))(set! upstreams(cadr looked))(set! spec-name(car looked))))((and(pair? look)(eq?  'scm_init_module(car look))(cdr look))=>(lambda(looked)(set! sharlib-full(cdr(last-pair looked)))(set! upstreams(cadr looked))(set! C-link-init-func(car looked))))(else(let*((s+l(let loop((dirs "")(syms module-name))(if(null?(cdr syms))(cons dirs(string-append "lib"(car syms)))(loop(string-append dirs(car syms)"/")(cdr syms)))))(subdir(car s+l))(libname(cdr s+l))(shortlibname(substring libname 3)))(define(libtool-name dir name)(let((dot-la(in-vicinity dir(string-append name ".la"))))(and(file-exists? dot-la)dot-la)))(define(sharlib-name dir name)(let((dot-so(in-vicinity dir(string-append name ".so"))))(and(file-exists? dot-so)dot-so)))(let check-dirs((dir-list %load-path))(or(null? dir-list)(let((dir(in-vicinity(car dir-list)subdir)))(cond((or(sharlib-name dir shortlibname)(libtool-name dir libname)(sharlib-name dir libname))=>(lambda(full)(set! sharlib-full full)(set! C-link-init-func(let*((c!(lambda(c)(if(or(char-alphabetic? c)(char-numeric? c))c #\_)))(sls(map(lambda(sym)(string->list(symbol->string sym)))module-name))(pre(map(lambda(ls)(cons #\_(map c! ls)))sls)))(list->string(quasiquote(#\s #\c #\m #\_ #\i #\n #\i #\t(unquote-splicing(apply append pre))#\_ #\m #\o #\d #\u #\l #\e)))))))(else(check-dirs(cdr dir-list))))))))))(and sharlib-full(or C-link-init-func spec-name)(let((up-i-ls(if upstreams(map(lambda(up)(cons up(resolve-interface up)))upstreams) '()))(dynobj(dynamic-link sharlib-full)))(and C-link-init-func(dynamic-call C-link-init-func dynobj))(and spec-name((BOOT #:reg)"f" dynobj(simple-format #f "guilemodspec_~A" spec-name)))(apply tbi! dynobj up-i-ls)))))(define(try-linked module-name)(init module-name))(define(try-dynamic-link module-name)(and(find+link module-name)(init module-name)))(lambda (command . args)(cond(first-time?(tbi!(BOOT #:self))(set! first-time? #f)))(apply(case command((#:try-linked)try-linked)((#:try-dynamic-link)try-dynamic-link)((#:init)init)((#:find+link)find+link)(else(error "No such command:" command)))args))))(define MU(let((BOOT BOOT)(process-define-module-hook(make-hook 2)))(define(unique-fob name)(case name((#:root)(BOOT #:root))((#:scm)(BOOT #:scm))(else #f)))(define(beautify-user-module! module)(let((interface(OB #:public-interface module)))(and(or(not interface)(eq? interface module))(OB #:set-public-interface! module(LL #:new:interface module))))(and(not(memq(BOOT #:scm)(LL #:uses module)))(not(eq? module(BOOT #:root)))(LL #:uses! module(append(LL #:uses module)(list(BOOT #:scm))))))(define(process-define-module args)(define(make-autoload-interface module name bindings)(LL #:new:autoload name(lambda(a sym definep)(and(memq sym bindings)(let((i(OB #:public-interface(module-name->fob name))))(or i(error "missing interface for module" name))(set-car!(memq a(LL #:uses module))i)(OB #:locvar i sym))))))(let*((module-id(car args))(module(module-name->fob module-id #f))(kws(cdr args))(unrecognized(lambda(arg)(error "unrecognized define-module argument" arg))))(beautify-user-module! module)(let loop((kws kws)(reversed-interfaces '())(exports '())(re-exports '()))(if(null? kws)(let((public-i(OB #:public-interface module)))(for-each(lambda(interface)(LL #:module-use! module interface))(reverse reversed-interfaces))(for-each(lambda(name)(OB #:fob-define! module name(OB #:fob-ref module name #f))(OB #:add! public-i name(OB #:var module name)))exports)(for-each(lambda(name)(OB #:add! public-i name(OB #:var module name)))re-exports))(let((k(let((k(car kws)))(cond((keyword? k)k)((and(symbol? k)(let((s(symbol->string k)))(and(char=? #\:(string-ref s 0))(make-shared-substring s 1))))=> symbol->keyword)(else(unrecognized kws))))))(case k((#:use)(loop(let acc((ls(reverse!(cadr kws)))(rest(cddr kws)))(if(null? ls)rest(acc(cdr ls)(list* #:use-module(car ls)rest))))reversed-interfaces exports re-exports))((#:use-module #:use-syntax)(or(pair?(cdr kws))(unrecognized kws))(let*((module-spec(cadr kws))(name(if(list?(car module-spec))(car module-spec)module-spec))(args(if(list?(car module-spec))(cdr module-spec) '()))(interface(apply resolve-interface name args)))(and(eq? k #:use-syntax)(or(symbol?(caar module-spec))(error "invalid module name for use-syntax"(car module-spec)))(LL #:transformer! module(OB #:fob-ref interface(car(last-pair(car module-spec)))#f)))(loop(cddr kws)(cons interface reversed-interfaces)exports re-exports)))((#:autoload)(or(and(pair?(cdr kws))(pair?(cddr kws)))(unrecognized kws))(loop(cdddr kws)(cons(make-autoload-interface module(cadr kws)(caddr kws))reversed-interfaces)exports re-exports))((#:no-backtrace)(LL #:set-system! module #t)(loop(cdr kws)reversed-interfaces exports re-exports))((#:export #:export-syntax)(or(pair?(cdr kws))(unrecognized kws))(loop(cddr kws)reversed-interfaces(append(cadr kws)exports)re-exports))((#:re-export #:re-export-syntax)(or(pair?(cdr kws))(unrecognized kws))(loop(cddr kws)reversed-interfaces exports(append(cadr kws)re-exports)))(else(cond(process-define-module-hook =>(lambda(hook)(for-each(lambda(handler)(cond((handler kws reversed-interfaces)=>(lambda(res)(loop(car res)(cdr res)exports re-exports)))))(hook->list hook))))(else(unrecognized kws))))))))module))(define(process-use-modules module-specs)(for-each(lambda(module-spec)(let*((name(if(list?(car module-spec))(car module-spec)module-spec))(args(if(list?(car module-spec))(cdr module-spec) '()))(mod-iface(apply resolve-interface name args)))(or mod-iface(error "no such module" module-spec))(LL #:module-use!(PV #:focus)mod-iface)))(reverse module-specs)))(define(SMACO name magic)(and(eq? magic BOOT)(case name((#:beautify-user-module!)beautify-user-module!)(else #f))))(lambda (command . args)(apply(case command((#:unique-fob)unique-fob)((#:module-name->fob)module-name->fob)((#:beautify-user-module!)beautify-user-module!)((#:process-define-module)process-define-module)((#:process-use-modules)process-use-modules)((#:SMACO)SMACO)(else(error "No such command:" command)))args))))(BOOT #:root!(let((m(LL #:new '(guile)#f 1019(lambda(m s define?)(let((bi(and(symbol-interned? #f s)(builtin-variable s))))(and bi(or define?(variable-bound? bi))(begin(OB #:add! m s bi)bi)))))))(LL #:set-system! m #t)m))(BOOT #:scm!(let((m(LL #:new '(guile) 'interface 1019(lambda(m s define?)(let((bi(and(symbol-interned? #f s)(builtin-variable s))))(and bi(variable-bound? bi)(begin(OB #:add! m s bi)bi)))))))(LL #:set-system! m #t)(OB #:set-public-interface!(BOOT #:root)m)m))(PV #:set-focus!(BOOT #:root))(biv!(car(BOOT #:mpre))(LL #:new #f #f 31))(NL #:local-define(BOOT #:mpre)(LL #:new #f #f 31))(NL #:local-define(append(BOOT #:mpre) '(guile))(BOOT #:root))(biv!  '#{%%\ mtargeiec\ %%}#(let((secrets(let*((BOOT BOOT)(SMACO(lambda(who what)(who #:SMACO what BOOT))))(list(BOOT #:root)(SMACO PV #:focus)(SMACO PV #:set-focus!)(BOOT #:mpre)(SMACO NL #:make-modules-in)(SMACO MU #:beautify-user-module!)(SMACO LL #:eval-closure)module-name->fob try-module-autoload(SMACO NL #:local-ref)(SMACO OB #:fob-ref)(SMACO OB #:fob-define!)))))(lambda(component)(if(and secrets(eq? #{%%\ mtargeiec\ %%}# component))(let((rv secrets))(set! secrets #f)rv)(case component((#:LL)LL)((#:OB)OB)((#:NL)NL)((#:MC)MC)((#:CAT)MC)((#:PV)PV)((#:MU)MU)(else(error "bad component:" component)))))))(biv!  'module-make-local-var!(lambda(m v)(OB #:make-local-var! m v)))(MC #:recheck-catalogs!))
(provide  'module-catalogs)
(define(primitive-macro? m)(and(macro? m)(not(macro-transformer m))))
(define macro-table(make-hash-table #:size 523 #:weakness #:key))
(define xformer-table(make-hash-table #:size 523 #:weakness #:key))
(define(defmacro? m)(hashq-ref macro-table m))
(define(assert-defmacro?! m)(hashq-set! macro-table m #t))
(define(defmacro-transformer m)(hashq-ref xformer-table m))
(define(set-defmacro-transformer! m t)(hashq-set! xformer-table m t))
(define defmacro:transformer(lambda(f)(let*((xform(lambda(exp env)(copy-tree(apply f(cdr exp)))))(a(procedure->memoizing-macro xform)))(assert-defmacro?! a)(set-defmacro-transformer! a f)a)))
(define defmacro(let((defmacro-transformer(lambda (name parms . body)(let((transformer(quasiquote(lambda(unquote parms)(unquote-splicing body)))))(quasiquote(define(unquote name)((unquote(lambda(transformer)(defmacro:transformer transformer)))(unquote transformer))))))))(defmacro:transformer defmacro-transformer)))
(define defmacro:syntax-transformer(lambda(f)(procedure->syntax(lambda(exp env)(copy-tree(apply f(cdr exp)))))))
(define(macroexpand-1 e)(cond((pair? e)(let*((a(car e))(val(and(symbol? a)((#{%%\ mtargeiec\ %%}# #:NL)#:local-ref(list a)))))(if(defmacro? val)(apply(defmacro-transformer val)(cdr e))e)))(#t e)))
(define(macroexpand e)(cond((pair? e)(let*((a(car e))(val(and(symbol? a)((#{%%\ mtargeiec\ %%}# #:NL)#:local-ref(list a)))))(if(defmacro? val)(macroexpand(apply(defmacro-transformer val)(cdr e)))e)))(#t e)))
(define(gentemp)(gensym "scm:G"))
(provide  'defmacro)
(define %define-option-interface(let*((option-name car)(option-value cadr)(option-documentation caddr)(print-option(lambda(option)(display(option-name option))(and(<(string-length(symbol->string(option-name option)))8)(display #\ht))(display #\ht)(display(option-value option))(display #\ht)(display(option-documentation option))(newline)))(make-options(lambda(interface)(quasiquote(lambda args(cond((null? args)((unquote interface)))((list?(car args))((unquote interface)(car args))((unquote interface)))(else(for-each(unquote print-option)((unquote interface)#t))))))))(make-enable(lambda(interface)(quasiquote(lambda flags((unquote interface)(append flags((unquote interface))))((unquote interface))))))(make-disable(lambda(interface)(quasiquote(lambda flags(let((options((unquote interface))))(for-each(lambda(flag)(set! options(delq! flag options)))flags)((unquote interface)options)((unquote interface)))))))(make-set!(lambda(interface)(quasiquote((name exp)((unquote  'quasiquote)(begin((unquote interface)(append((unquote interface))(list '((unquote  'unquote)name)((unquote  'unquote)exp))))((unquote interface)))))))))(procedure->memoizing-macro(lambda(exp env)(cons  'begin(let*((option-group(cadr exp))(interface(car option-group)))(append(map(lambda(name constructor)(quasiquote(define(unquote name)(unquote(constructor interface)))))(cadr option-group)(list make-options make-enable make-disable))(map(lambda(name constructor)(quasiquote(defmacro(unquote name)(unquote-splicing(constructor interface)))))(caddr option-group)(list make-set!)))))))))
(%define-option-interface(eval-options-interface(eval-options eval-enable eval-disable)(eval-set!)))
(%define-option-interface(debug-options-interface(debug-options debug-enable debug-disable)(debug-set!)))
(%define-option-interface(evaluator-traps-interface(traps trap-enable trap-disable)(trap-set!)))
(%define-option-interface(read-options-interface(read-options read-enable read-disable)(read-set!)))
(%define-option-interface(print-options-interface(print-options print-enable print-disable)(print-set!)))
(define(repl read evaler print)(let loop((source(read(current-input-port))))(print(evaler source))(loop(read(current-input-port)))))
(define scm-repl-silent #f)
(define(assert-repl-silence v)(set! scm-repl-silent v))
(define *unspecified*(unspecified))
(define scm-repl-print-unspecified #f)
(define(assert-repl-print-unspecified v)(set! scm-repl-print-unspecified v))
(define scm-repl-verbose #f)
(define(assert-repl-verbosity v)(set! scm-repl-verbose v))
(define scm-repl-prompt "guile> ")
(define(set-repl-prompt! v)(set! scm-repl-prompt v))
(define (default-lazy-handler key . args)(save-stack lazy-handler-dispatch)(apply throw key args))
(define enter-frame-handler default-lazy-handler)
(define apply-frame-handler default-lazy-handler)
(define exit-frame-handler default-lazy-handler)
(define (lazy-handler-dispatch key . args)(case key((apply-frame)(apply apply-frame-handler key args))((exit-frame)(apply exit-frame-handler key args))((enter-frame)(apply enter-frame-handler key args))(else(apply default-lazy-handler key args))))
(define abort-hook(make-hook))
(define(set-batch-mode?! arg)#t)
(define(batch-mode?)#t)
(define has-shown-debugger-hint? #f)
(define stack-saved? #f)
(define before-error-hook(make-hook))
(define after-error-hook(make-hook))
(define before-backtrace-hook(make-hook))
(define after-backtrace-hook(make-hook))
(define (handle-system-error key . args)(let((cep(current-error-port)))(cond((not(stack?(fluid-ref the-last-stack))))((memq  'backtrace(debug-options-interface))(run-hook before-backtrace-hook)(newline cep)(display "Backtrace:\n")(display-backtrace(fluid-ref the-last-stack)cep)(newline cep)(run-hook after-backtrace-hook)))(run-hook before-error-hook)(apply display-error(fluid-ref the-last-stack)cep args)(run-hook after-error-hook)(force-output cep)(throw  'abort key)))
(define (quit . exit-val)(apply throw  'quit exit-val))
(define(error-catching-loop thunk)(let((status #f)(interactive #t))(define(loop first)(let((next(catch #t(lambda()(lazy-catch #t(lambda()(dynamic-wind(lambda()(unmask-signals))(lambda()(with-traps(lambda()(first)(set! first #f)(let loop((v(thunk)))(loop(thunk)))#f)))(lambda()(mask-signals))))lazy-handler-dispatch))(lambda (key . args)(case key((quit)(set! status args)#f)((switch-repl)(apply throw  'switch-repl args))((abort)(lambda()(run-hook abort-hook)(force-output(current-output-port))(display "ABORT: "(current-error-port))(write args(current-error-port))(newline(current-error-port))(if interactive(begin(and(not has-shown-debugger-hint?)(not(memq  'backtrace(debug-options-interface)))(stack?(fluid-ref the-last-stack))(begin(newline(current-error-port))(display "Type \"(backtrace)\" to get more information or \"(debug)\" to enter the debugger.\n"(current-error-port))(set! has-shown-debugger-hint? #t)))(force-output(current-error-port)))(begin(primitive-exit 1)))(set! stack-saved? #f)))(else(lambda()(cond((=(length args)4)(apply handle-system-error key args))(else(apply bad-throw key args))))))))))(if next(loop next)status)))(set! set-batch-mode?!(lambda(arg)(cond(arg(set! interactive #f)(restore-signals))(#t(error "sorry, not implemented")))))(set! batch-mode?(lambda()(not interactive)))(loop(lambda()#t))))
(define before-signal-stack(make-fluid))
(define (save-stack . narrowing)(or stack-saved?(cond((not(memq  'debug(debug-options-interface)))(fluid-set! the-last-stack #f)(set! stack-saved? #t))(else(fluid-set! the-last-stack(case(stack-id #t)((repl-stack)(apply make-stack #t save-stack eval #t 0 narrowing))((load-stack)(apply make-stack #t save-stack 0 #t 0 narrowing))((tk-stack)(apply make-stack #t save-stack tk-stack-mark #t 0 narrowing))((#t)(apply make-stack #t save-stack 0 1 0 narrowing))(else(let((id(stack-id #t)))(and(procedure? id)(apply make-stack #t save-stack id #t 0 narrowing))))))(set! stack-saved? #t)))))
(define exit quit)
(define(error-catching-repl r e p)(error-catching-loop(lambda()(p(e(r))))))
(define(gc-run-time)(cdr(assq  'gc-time-taken(gc-stats))))
(define before-read-hook(make-hook))
(define after-read-hook(make-hook))
(define repl-reader(lambda(prompt)(display prompt)(force-output)(run-hook before-read-hook)(read(current-input-port))))
(define(scm-style-repl)(let((start-gc-rt #f)(start-rt #f))(define(repl-report-start-timing)(set! start-gc-rt(gc-run-time))(set! start-rt(get-internal-run-time)))(define(repl-report)(display ";;; ")(display(inexact->exact(* 1000(/(-(get-internal-run-time)start-rt)internal-time-units-per-second))))(display "  msec  (")(display(inexact->exact(* 1000(/(-(gc-run-time)start-gc-rt)internal-time-units-per-second))))(display " msec in gc)\n"))(define(consume-trailing-whitespace)(let((ch(peek-char)))(cond((eof-object? ch))((or(char=? ch #\space)(char=? ch #\ht))(read-char)(consume-trailing-whitespace))((char=? ch #\newline)(set-port-column!(current-output-port)0)(read-char)))))(define(-read)(let((val(let((prompt(cond((string? scm-repl-prompt)scm-repl-prompt)((thunk? scm-repl-prompt)(scm-repl-prompt))(scm-repl-prompt "> ")(else ""))))(repl-reader prompt))))(or(eof-object? val)(consume-trailing-whitespace))(run-hook after-read-hook)(and(eof-object? val)(begin(repl-report-start-timing)(and scm-repl-verbose(begin(newline)(display ";;; EOF -- quitting")(newline)))(quit 0)))val))(define(-eval sourc)(repl-report-start-timing)(start-stack  'repl-stack(eval sourc)))(define(-print result)(or scm-repl-silent(begin(and(or scm-repl-print-unspecified(not(unspecified? result)))(begin(write result)(newline)))(and scm-repl-verbose(repl-report))(force-output))))(define(-quit args)(and scm-repl-verbose(begin(display ";;; QUIT executed, repl exitting")(newline)(repl-report)))args)(define(-abort)(and scm-repl-verbose(begin(display ";;; ABORT executed.")(newline)(repl-report)))(repl -read -eval -print))(let((status(error-catching-repl -read -eval -print)))(-quit status))))
(defmacro while (cond . body)(let((tag(gensym "while-catch-tag")))(quasiquote(letrec((continue(lambda()(if(not(unquote cond))(throw '(unquote tag)#t)(begin(begin(unquote-splicing body))(continue)))))(break(lambda val(throw '(unquote tag)(or(null? val)(car val))))))(catch '(unquote tag)(lambda()(continue))(lambda tag-val(cadr tag-val)))))))
(defmacro collect forms(cons  'list forms))
(defmacro with-fluids (bindings . body)(quasiquote(with-fluids*(list(unquote-splicing(map car bindings)))(list(unquote-splicing(map cadr bindings)))(lambda()(unquote-splicing body)))))
(define the-environment(procedure->syntax(lambda(x e)e)))
(define(environment-module env)(let((closure(and(pair? env)(car(last-pair env)))))(and closure(procedure-property closure  'module))))
(define(interaction-environment)((#{%%\ mtargeiec\ %%}# #:PV)#:focus))
(define(scheme-report-environment n)(or(= 5 n)(error "bad version:" n))(error "not yet implemented"))
(define(null-environment n)(or(= 5 n)(error "bad version:" n))(error "not yet implemented"))
(defmacro define-macro (first . rest)(let((name(if(symbol? first)first(car first)))(transformer(if(symbol? first)(car rest)(quasiquote(lambda(unquote(cdr first))(unquote-splicing rest))))))(quasiquote(define(unquote name)(defmacro:transformer(unquote transformer))))))
(defmacro define-syntax-macro (first . rest)(let((name(if(symbol? first)first(car first)))(transformer(if(symbol? first)(car rest)(quasiquote(lambda(unquote(cdr first))(unquote-splicing rest))))))(quasiquote(define(unquote name)(defmacro:syntax-transformer(unquote transformer))))))
(defmacro define-module args(quasiquote(let((set-focus!(lambda(m)((#{%%\ mtargeiec\ %%}# #:PV)#:set-focus! m)))(module((#{%%\ mtargeiec\ %%}# #:MU)#:process-define-module '(unquote args))))(set-focus! module)module)))
(defmacro use-modules module-specs(quasiquote((#{%%\ mtargeiec\ %%}# #:MU)#:process-use-modules '(unquote module-specs))))
(defmacro use-syntax(spec)(quasiquote(let*((T #{%%\ mtargeiec\ %%}#)(MU(T #:MU))(LL(T #:LL))(cur((T #:PV)#:focus)))(unquote-splicing(if(pair? spec)(quasiquote((MU #:process-use-modules '(unquote(list spec)))(LL #:transformer! cur(unquote(car(last-pair spec))))))(quasiquote((LL #:transformer! cur(unquote spec))))))(set! scm:eval-transformer(LL #:transformer cur)))))
(define define-private define)
(defmacro define-public args(define(syntax)(error "bad syntax"(list  'define-public args)))(define(defined-name n)(cond((symbol? n)n)((pair? n)(defined-name(car n)))(else(syntax))))(cond((null? args)(syntax))(#t(let((name(defined-name(car args))))(quasiquote(begin(let*((T #{%%\ mtargeiec\ %%}#)(OB(T #:OB))(cur((T #:PV)#:focus))(public-i(OB #:public-interface cur)))(OB #:fob-define! cur '(unquote name)(OB #:fob-ref cur '(unquote name)#f))(OB #:add! public-i '(unquote name)(OB #:var cur '(unquote name))))(eval '(define-private(unquote-splicing args)))))))))
(defmacro defmacro-public args(define(syntax)(error "bad syntax"(list  'defmacro-public args)))(define(defined-name n)(cond((symbol? n)n)(else(syntax))))(cond((null? args)(syntax))(#t(let((name(defined-name(car args))))(quasiquote(begin(let*((T #{%%\ mtargeiec\ %%}#)(OB(T #:OB))(cur((T #:PV)#:focus))(public-i(OB #:public-interface cur)))(OB #:fob-define! cur '(unquote name)(OB #:fob-ref cur '(unquote name)#f))(OB #:add! public-i '(unquote name)(OB #:var cur '(unquote name))))(defmacro(unquote-splicing args))))))))
(defmacro export names(quasiquote(let*((T #{%%\ mtargeiec\ %%}#)(OB(T #:OB))(m((T #:PV)#:focus))(public-i(OB #:public-interface m)))(for-each(lambda(name)(OB #:fob-define! m name(OB #:fob-ref m name #f))(OB #:add! public-i name(OB #:var m name))) '(unquote names)))))
(define export-syntax export)
(define(load filename)((#{%%\ mtargeiec\ %%}# #:PV)#:module-aware-load filename))
(define %cond-expand-features '(guile r5rs srfi-0))
(define %cond-expand-table(make-hash-table #:size 31))
(define(cond-expand-provide module features)(and=>(let((T #{%%\ mtargeiec\ %%}#))((T #:OB)#:public-interface(if(eq? #t module)((T #:PV)#:focus)module)))(lambda(pi)(hashq-set! %cond-expand-table pi(append(hashq-ref %cond-expand-table pi '())features)))))
(define cond-expand(procedure->memoizing-macro(lambda(exp env)(let((clauses(cdr exp))(syntax-error(lambda(cl)(error "invalid clause in `cond-expand'" cl))))(letrec((test-clause(lambda(clause)(cond((symbol? clause)(or(memq clause %cond-expand-features)(let lp((uses((#{%%\ mtargeiec\ %%}# #:LL)#:uses(env-module env))))(if(pair? uses)(or(memq clause(hashq-ref %cond-expand-table(car uses) '()))(lp(cdr uses)))#f))))((pair? clause)(cond((eq?  'and(car clause))(let lp((l(cdr clause)))(cond((null? l)#t)((pair? l)(and(test-clause(car l))(lp(cdr l))))(else(syntax-error clause)))))((eq?  'or(car clause))(let lp((l(cdr clause)))(cond((null? l)#f)((pair? l)(or(test-clause(car l))(lp(cdr l))))(else(syntax-error clause)))))((eq?  'not(car clause))(cond((not(pair?(cdr clause)))(syntax-error clause))((pair?(cddr clause))((syntax-error clause))))(not(test-clause(cadr clause))))(else(syntax-error clause))))(else(syntax-error clause))))))(let lp((c clauses))(cond((null? c)(error "Unfulfilled `cond-expand'"))((not(pair? c))(syntax-error c))((not(pair?(car c)))(syntax-error(car c)))((test-clause(caar c))(quasiquote(begin(unquote-splicing(cdar c)))))((eq?(caar c) 'else)(and(pair?(cdr c))(syntax-error c))(quasiquote(begin(unquote-splicing(cdar c)))))(else(lp(cdr c))))))))))
(define using-readline?(let((using-readline?(make-fluid)))(make-procedure-with-setter(lambda()(fluid-ref using-readline?))(lambda(v)(fluid-set! using-readline? v)))))
(define exit-hook(make-hook))
(define(top-repl)(cond((and((#{%%\ mtargeiec\ %%}# #:OB)#:fob-defined?((#{%%\ mtargeiec\ %%}# #:MU)#:unique-fob #:root) '%%use-emacs-interface)%%use-emacs-interface)(and(provided?  'debug-extensions)(debug-enable  'backtrace))(define-module(guile-user)#:use-module(ice-9 emacs))))(define-module(guile-user))(let((old-handlers #f)(signals(if(provided?  'posix)(quasiquote(((unquote SIGINT) . "User interrupt") ((unquote SIGFPE) . "Arithmetic error") ((unquote SIGBUS) . "Bad memory access (bus error)") ((unquote SIGSEGV) . "Bad memory access (Segmentation violation)"))) '())))(dynamic-wind(lambda()(let((make-handler(lambda(msg)(lambda(sig)(fluid-set! before-signal-stack(fluid-ref the-last-stack))(save-stack %deliver-signals)(scm-error  'signal #f msg #f(list sig))))))(set! old-handlers(map(lambda(sig-msg)(sigaction(car sig-msg)(make-handler(cdr sig-msg))))signals))))(lambda()(let((status(scm-style-repl)))(run-hook exit-hook)status))(lambda()(map(lambda(sig-msg old-handler)(if(not(car old-handler))(sigaction(car sig-msg)#f)(sigaction(car sig-msg)(car old-handler)(cdr old-handler))))signals old-handlers)))))
(defmacro false-if-exception (expr . rest)(quasiquote(catch #t(lambda()(unquote expr)(unquote-splicing rest))(lambda args #f))))
(define(command-line)(program-arguments))
(define(load-user-init)(let*((home(or(getenv "HOME")(false-if-exception(passwd:dir(getpwuid(getuid))))"/"))(init-file(in-vicinity home ".guile")))(and(file-exists? init-file)(primitive-load init-file))))
(define-module(guile)#:autoload(ice-9 rdelim)(read-line read-line! read-delimited read-delimited! write-line))
(define-module(guile-user)#:use-module(guile)#:autoload(ice-9 cmdline-opts)(get-option for-next-option display-usage-report transform-usage-lambda)#:autoload(ice-9 session)(help apropos apropos-internal apropos-fold apropos-fold-accessible apropos-fold-exported apropos-fold-all source arity system-module)#:autoload(ice-9 debug)(frame-number->index trace untrace)#:autoload(ice-9 debugger)(debug))
(if(provided?  'threads)(define-module(guile-user)#:autoload(ice-9 threads)(%thread-handler make-thread begin-thread with-mutex monitor)))
(if(provided?  'regex)(define-module(guile-user)#:autoload(ice-9 regex)(match:count match:string match:prefix match:suffix regexp-match? regexp-quote match:start match:end match:substring string-match regexp-substitute fold-matches list-matches regexp-substitute/global)))
(append! %load-path(list "."))
(define-module(guile-user))
