(define-module(ice-9 debug))
(define-public (frame-number->index n . stack)(let((stack(if(null? stack)(fluid-ref the-last-stack)(car stack))))(if(memq  'backwards(debug-options))n(-(stack-length stack)n 1))))
(define traced-procedures '())
(define-public (trace . args)(if(null? args)(nameify traced-procedures)(begin(for-each(lambda(proc)(or(procedure? proc)(error "trace: Wrong type argument:" proc))(set-procedure-property! proc  'trace #t)(or(memq proc traced-procedures)(set! traced-procedures(cons proc traced-procedures))))args)(set! apply-frame-handler trace-entry)(set! exit-frame-handler trace-exit)(set! trace-level 0)(debug-enable  'trace)(nameify args))))
(define-public (untrace . args)(if(and(null? args)(not(null? traced-procedures)))(apply untrace traced-procedures)(begin(for-each(lambda(proc)(set-procedure-property! proc  'trace #f)(set! traced-procedures(delq! proc traced-procedures)))args)(and(null? traced-procedures)(debug-disable  'trace))(nameify args))))
(define(nameify ls)(map(lambda(proc)(let((name(procedure-name proc)))(or name proc)))ls))
(define trace-level 0)
(add-hook! abort-hook(lambda()(set! trace-level 0)))
(define(trace-entry key cont tail)(and(eq?(stack-id cont) 'repl-stack)(let((cep(current-error-port))(frame(last-stack-frame cont)))(or tail(set! trace-level(+ trace-level 1)))(let indent((n trace-level))(cond((> n 1)(display "|  " cep)(indent(- n 1)))))(display-application frame cep)(newline cep))))
(define(trace-exit key cont retval)(and(eq?(stack-id cont) 'repl-stack)(let((cep(current-error-port)))(set! trace-level(- trace-level 1))(let indent((n trace-level))(cond((> n 0)(display "|  " cep)(indent(- n 1)))))(write retval cep)(newline cep))))
(variable-set!(builtin-variable  'debug-options)debug-options)
(debug-enable  'debug)
(read-enable  'positions)
