(define-module(ice-9 documentation)#:use-module(ice-9 rdelim)#:use-module((ice-9 accumulate)#:select(accumulator))#:export(file-commentary module-commentary documentation-files search-documentation-files object-documentation)#:autoload(ice-9 regex)(match:suffix)#:autoload(ice-9 gumm)(module-catalog-manager)#:no-backtrace)
(define default-in-line-re(make-regexp "^;;; Commentary:"))
(define default-after-line-re(make-regexp "^;;; Code:"))
(define default-scrub(let((dirt(make-regexp "^(;+ |;+)")))(lambda(line)(let((m(regexp-exec dirt line)))(if m(match:suffix m)line)))))
(define (file-commentary filename . cust)(let*((n(length cust))(in-line-re(let((v(and(< 0 n)(car cust))))(cond((regexp? v)v)((string? v)(make-regexp v))(else default-in-line-re))))(after-line-re(let((v(and(< 1 n)(cadr cust))))(cond((regexp? v)v)((string? v)(make-regexp v))(else default-after-line-re))))(scrub(let((v(and(< 2 n)(caddr cust))))(cond((procedure? v)v)(else default-scrub))))(ls(accumulator))(port(open-input-file filename)))(let loop((collect? #f))(let((line(read-delimited "\n" port)))(cond((or(eof-object? line)(and collect?(regexp-exec after-line-re line)))(close-port port)(apply string-append(ls)))(collect?(ls(scrub line)"\n")(loop #t))(else(loop(regexp-exec in-line-re line))))))))
(define(module-commentary module-name)(or(and=>(module-catalog-manager #:name-to-cat-entry module-name)(lambda(entry)(file-commentary(if(string? entry)entry(cdr(last-pair entry))))))""))
(define documentation-files(let((fn "guile-procedures.gdf1"))(cons(in-vicinity(%package-data-dir)(in-vicinity(version)fn))(if(file-exists? fn)(list fn) '()))))
(define(find-documentation name)(or-map(lambda(file)(find-documentation-in-file name file))documentation-files))
(define entry-delimiter "\f")
(define entry-start 2)
(define(find-documentation-in-file name file)(and(file-exists? file)(call-with-input-file file(lambda(port)(let*((name(symbol->string name))(len(string-length name))(min-size(+ entry-start len))(end(+ entry-start len)))(read-delimited entry-delimiter port)(let loop((entry(read-delimited entry-delimiter port)))(cond((eof-object? entry)#f)((and(>=(string-length entry)min-size)(string=?(substring entry entry-start end)name)(memq(string-ref entry end) '(#\space #\))))(substring entry 1(-(string-length entry)1)))(else(loop(read-delimited entry-delimiter port))))))))))
(define (search-documentation-files name . files)(or-map(lambda(file)(find-documentation-in-file name file))(if(null? files)documentation-files files)))
(define(proc-doc proc)(or(procedure-documentation proc)(procedure-property proc  'documentation)))
(define(object-documentation object)(or(and(procedure? object)(proc-doc object))(and(macro? object)(and=>(macro-transformer object)proc-doc))(object-property object  'documentation)(and(procedure? object)(not(closure? object))(procedure-name object)(and=>(find-documentation(procedure-name object))(lambda(docstring)(set-procedure-property! object  'documentation docstring)docstring)))))
